Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/MultiComponentVectorMoveHardTabuCriterion.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/MultiComponentVectorMoveHardTabuCriterion.cs	(revision 9472)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/MultiComponentVectorMoveHardTabuCriterion.cs	(revision 9473)
@@ -94,7 +94,9 @@
     private bool IsMoveTabu(ItemList<IItem> tabuList, MultiComponentVectorMove move, MultiComponentVectorEncoding multiComponentVector, double moveQuality, bool maximization, bool useAspiration) {
       bool isTabu = false;
-      SingleItemRotationMove sirm = move as SingleItemRotationMove;  
-      SingleGroupingMove sgm = move as SingleGroupingMove;   
-      SwapSequenceMove ssm = move as SwapSequenceMove;
+      SingleItemRotationMove sirm = move as SingleItemRotationMove;
+      SingleGroupingMove sgm = move as SingleGroupingMove;
+      SwapPositionMove spm = move as SwapPositionMove;
+      ChangePositionMove cpm = move as ChangePositionMove;
+      MCVTripleMove tm = move as MCVTripleMove;
       var attributes = tabuList.FindAll(ta => ta.GetType().Equals(move.GetMoveAttributeType()));
 
@@ -102,4 +104,6 @@
         foreach (IItem tabuMove in attributes) {
           SingleItemRotationMoveAttribute sirmAttr = (tabuMove as SingleItemRotationMoveAttribute);
+          if (sirmAttr.MoveQuality.Equals(moveQuality))
+            return true;
           if (sirmAttr != null
             && (!useAspiration
@@ -114,24 +118,62 @@
         foreach (IItem tabuMove in attributes) {
           SingleGroupingMoveAttribute sgmAttr = (tabuMove as SingleGroupingMoveAttribute);
+          if (sgmAttr.MoveQuality.Equals(moveQuality))
+            return true;
           if (sgmAttr != null
             && (!useAspiration
                 || maximization && moveQuality <= sgmAttr.MoveQuality
                 || !maximization && moveQuality >= sgmAttr.MoveQuality)) {
-                  if (sgm.ItemIndex == sgmAttr.ItemIndex || multiComponentVector.PackingInformations[sgm.ItemIndex].AssignedBin == sgmAttr.AssignedBin)
+                  if ( multiComponentVector.PackingInformations[sgm.Index].ItemIndex ==  multiComponentVector.PackingInformations[sgmAttr.Index].ItemIndex
+                    || multiComponentVector.PackingInformations[sgm.Index].AssignedBin == sgmAttr.AssignedBin)
                     isTabu = true;
           }
           if (isTabu) break;
         }
-      } else if (ssm != null) {
+      } else if (spm != null) {
         foreach (IItem tabuMove in attributes) {
-          SwapSequenceMoveAttribute ssmAttr = (tabuMove as SwapSequenceMoveAttribute);
-          if (ssmAttr != null
+          SwapPositionMoveAttribute spmAttr = (tabuMove as SwapPositionMoveAttribute);
+          if (spmAttr.MoveQuality.Equals(moveQuality))
+            return true;
+          if (spmAttr != null
             && (!useAspiration
-                || maximization && moveQuality <= ssmAttr.MoveQuality
-                || !maximization && moveQuality >= ssmAttr.MoveQuality)) {
-                  if (ssm.Index1 == ssmAttr.Index1
-                    || ssm.Index2 == ssmAttr.Index2
-                    || multiComponentVector.PackingInformations[ssm.Index1].ItemIndex == ssmAttr.ItemIndex1
-                    || multiComponentVector.PackingInformations[ssm.Index2].ItemIndex == ssmAttr.ItemIndex2)
+                || maximization && moveQuality <= spmAttr.MoveQuality
+                || !maximization && moveQuality >= spmAttr.MoveQuality)) {
+            if (spm.Index1 == spmAttr.Index1
+              || spm.Index2 == spmAttr.Index2
+              || multiComponentVector.PackingInformations[spm.Index1].ItemIndex == spmAttr.ItemIndex1
+              || multiComponentVector.PackingInformations[spm.Index2].ItemIndex == spmAttr.ItemIndex2)
+              isTabu = true;
+          }
+          if (isTabu) break;
+        }
+      } else if (cpm != null) {
+        foreach (IItem tabuMove in attributes) {
+          ChangePositionMoveAttribute cpmAttr = (tabuMove as ChangePositionMoveAttribute);
+          if (cpmAttr.MoveQuality.Equals(moveQuality))
+            return true;
+          if (cpmAttr != null
+            && (!useAspiration
+                || maximization && moveQuality <= cpmAttr.MoveQuality
+                || !maximization && moveQuality >= cpmAttr.MoveQuality)) {
+            if (cpm.Index == cpmAttr.Index
+        || cpm.TargetIndex == cpmAttr.TargetIndex
+        || multiComponentVector.PackingInformations[cpm.Index].ItemIndex == cpmAttr.ItemIndex)
+              isTabu = true;
+          }
+          if (isTabu) break;
+        }
+      } else if (tm != null) {
+        foreach (IItem tabuMove in attributes) {
+          MCVTripleMoveAttribute tmAttr = (tabuMove as MCVTripleMoveAttribute);
+          if (tmAttr.MoveQuality.Equals(moveQuality))
+            return true;
+          if (tmAttr != null
+            && (!useAspiration
+                || maximization && moveQuality <= tmAttr.MoveQuality
+                || !maximization && moveQuality >= tmAttr.MoveQuality)) {
+                  if ((tm.Index == tmAttr.Index && tm.TargetIndex == tmAttr.TargetIndex)
+                      || tm.Index == tmAttr.Index
+                      || multiComponentVector.PackingInformations[tm.Index].ItemIndex == tmAttr.ItemIndex
+                    )
               isTabu = true;
           }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/MultiComponentVectorMoveMaker.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/MultiComponentVectorMoveMaker.cs	(revision 9472)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/MultiComponentVectorMoveMaker.cs	(revision 9473)
@@ -66,9 +66,9 @@
     public override IOperation Apply() {
       MultiComponentVectorMove move = MultiComponentVectorMoveParameter.ActualValue;
-      MultiComponentVectorEncoding MultiComponentVector = MultiComponentVectorParameter.ActualValue;
+      MultiComponentVectorEncoding multiComponentVector = MultiComponentVectorParameter.ActualValue;
       DoubleValue moveQuality = MoveQualityParameter.ActualValue;
       DoubleValue quality = QualityParameter.ActualValue;
 
-      MultiComponentVector = move.GetVectorAfterMove();
+      multiComponentVector.PackingInformations = move.GetVectorAfterMove().PackingInformations;
 
       quality.Value = moveQuality.Value;
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/MultiComponentVectorMoveSoftTabuCriterion.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/MultiComponentVectorMoveSoftTabuCriterion.cs	(revision 9472)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/MultiComponentVectorMoveSoftTabuCriterion.cs	(revision 9473)
@@ -65,5 +65,5 @@
     public MultiComponentVectorMoveSoftTabuCriterion()
       : base() {
-        Parameters.Add(new LookupParameter<MultiComponentVectorMove>("MultiComponentVectorMove", "The move to evaluate."));
+      Parameters.Add(new LookupParameter<MultiComponentVectorMove>("MultiComponentVectorMove", "The move to evaluate."));
       Parameters.Add(new LookupParameter<MultiComponentVectorEncoding>("MultiComponentVector", "The solution to evaluate."));
       Parameters.Add(new LookupParameter<BoolValue>("MoveTabu", "The variable to store if a move was tabu."));
@@ -94,7 +94,10 @@
     private bool IsMoveTabu(ItemList<IItem> tabuList, MultiComponentVectorMove move, MultiComponentVectorEncoding multiComponentVector, double moveQuality, bool maximization, bool useAspiration) {
       bool isTabu = false;
-      SingleItemRotationMove sirm = move as SingleItemRotationMove;  
-      SingleGroupingMove sgm = move as SingleGroupingMove;   
-      SwapSequenceMove ssm = move as SwapSequenceMove;
+
+      SingleItemRotationMove sirm = move as SingleItemRotationMove;
+      SingleGroupingMove sgm = move as SingleGroupingMove;
+      SwapPositionMove spm = move as SwapPositionMove;
+      ChangePositionMove cpm = move as ChangePositionMove;
+      MCVTripleMove tm = move as MCVTripleMove;
       var attributes = tabuList.FindAll(ta => ta.GetType().Equals(move.GetMoveAttributeType()));
 
@@ -106,6 +109,6 @@
                 || maximization && moveQuality <= sirmAttr.MoveQuality
                 || !maximization && moveQuality >= sirmAttr.MoveQuality)) {
-                  if (sirm.ItemIndex == sirmAttr.ItemIndex && multiComponentVector.PackingInformations[sirm.ItemIndex].Rotated == sirmAttr.ItemRotation)
-                    isTabu = true;
+            if (sirm.ItemIndex == sirmAttr.ItemIndex && multiComponentVector.PackingInformations[sirm.ItemIndex].Rotated == sirmAttr.ItemRotation)
+              isTabu = true;
           }
           if (isTabu) break;
@@ -118,20 +121,51 @@
                 || maximization && moveQuality <= sgmAttr.MoveQuality
                 || !maximization && moveQuality >= sgmAttr.MoveQuality)) {
-                  if (sgm.ItemIndex == sgmAttr.ItemIndex && multiComponentVector.PackingInformations[sgm.ItemIndex].AssignedBin == sgmAttr.AssignedBin)
-                    isTabu = true;
+                  if (multiComponentVector.PackingInformations[sgm.Index].ItemIndex == multiComponentVector.PackingInformations[sgmAttr.Index].ItemIndex 
+              && multiComponentVector.PackingInformations[sgm.Index].AssignedBin == sgmAttr.AssignedBin)
+              isTabu = true;
           }
           if (isTabu) break;
         }
-      } else if (ssm != null) {
+      } else if (spm != null) {
         foreach (IItem tabuMove in attributes) {
-          SwapSequenceMoveAttribute ssmAttr = (tabuMove as SwapSequenceMoveAttribute);
-          if (ssmAttr != null
+          SwapPositionMoveAttribute spmAttr = (tabuMove as SwapPositionMoveAttribute);
+          if (spmAttr != null
             && (!useAspiration
-                || maximization && moveQuality <= ssmAttr.MoveQuality
-                || !maximization && moveQuality >= ssmAttr.MoveQuality)) {
-                  if (ssm.Index1 == ssmAttr.Index1
-                    && ssm.Index2 == ssmAttr.Index2
-                    && multiComponentVector.PackingInformations[ssm.Index1].ItemIndex == ssmAttr.ItemIndex1
-                    && multiComponentVector.PackingInformations[ssm.Index2].ItemIndex == ssmAttr.ItemIndex2)
+                || maximization && moveQuality <= spmAttr.MoveQuality
+                || !maximization && moveQuality >= spmAttr.MoveQuality)) {
+            if (spm.Index1 == spmAttr.Index1
+              && spm.Index2 == spmAttr.Index2
+              && multiComponentVector.PackingInformations[spm.Index1].ItemIndex == spmAttr.ItemIndex1
+              && multiComponentVector.PackingInformations[spm.Index2].ItemIndex == spmAttr.ItemIndex2)
+              isTabu = true;
+          }
+          if (isTabu) break;
+        }
+      } else if (cpm != null) {
+        foreach (IItem tabuMove in attributes) {
+          ChangePositionMoveAttribute cpmAttr = (tabuMove as ChangePositionMoveAttribute);
+          if (cpmAttr != null
+            && (!useAspiration
+                || maximization && moveQuality <= cpmAttr.MoveQuality
+                || !maximization && moveQuality >= cpmAttr.MoveQuality)) {
+            if (cpm.Index == cpmAttr.Index
+        && cpm.TargetIndex == cpmAttr.TargetIndex
+        && multiComponentVector.PackingInformations[cpm.Index].ItemIndex == cpmAttr.ItemIndex)
+              isTabu = true;
+          }
+          if (isTabu) break;
+        }
+      } else if (tm != null) {
+        foreach (IItem tabuMove in attributes) {
+          MCVTripleMoveAttribute tmAttr = (tabuMove as MCVTripleMoveAttribute);
+          if (tmAttr != null
+            && (!useAspiration
+                || maximization && moveQuality <= tmAttr.MoveQuality
+                || !maximization && moveQuality >= tmAttr.MoveQuality)) {
+            if ((tm.Index == tmAttr.Index && tm.TargetIndex == tmAttr.TargetIndex)
+                && multiComponentVector.PackingInformations[tm.Index].ItemIndex == tmAttr.ItemIndex
+                && tm.Rotation == !(tmAttr.RotationAfter.Equals(tmAttr.RotationBefore))
+                && (tm.Group == tmAttr.GroupAfter && multiComponentVector.PackingInformations[tm.Index].AssignedBin == tmAttr.GroupBefore)
+              )
               isTabu = true;
           }
@@ -140,5 +174,5 @@
       } 
 
-      
+
 
       return isTabu;
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/MultiComponentVectorTabuMaker.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/MultiComponentVectorTabuMaker.cs	(revision 9472)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/MultiComponentVectorTabuMaker.cs	(revision 9473)
@@ -64,8 +64,22 @@
       SingleGroupingMove sgm = move as SingleGroupingMove;
       if (sgm != null)
-        return new SingleGroupingMoveAttribute(sgm.ItemIndex, solution.PackingInformations[sgm.ItemIndex].AssignedBin, baseQuality);
-      SwapSequenceMove ssm = move as SwapSequenceMove;
-      if (ssm != null)
-        return new SwapSequenceMoveAttribute(ssm.Index1, ssm.Index2, solution.PackingInformations[ssm.Index1].ItemIndex, solution.PackingInformations[ssm.Index2].ItemIndex, baseQuality);
+        return new SingleGroupingMoveAttribute(sgm.Index, solution.PackingInformations[sgm.Index].AssignedBin, baseQuality);
+      SwapPositionMove spm = move as SwapPositionMove;
+      if (spm != null)
+        return new SwapPositionMoveAttribute(spm.Index1, spm.Index2, solution.PackingInformations[spm.Index1].ItemIndex, solution.PackingInformations[spm.Index2].ItemIndex, baseQuality);
+      ChangePositionMove cpm = move as ChangePositionMove;
+      if (cpm != null)
+        return new ChangePositionMoveAttribute(cpm.Index, cpm.TargetIndex, solution.PackingInformations[cpm.Index].ItemIndex, baseQuality);
+      MCVTripleMove tm = move as MCVTripleMove;
+      if (tm != null)
+        return new MCVTripleMoveAttribute(
+          tm.Index, 
+          tm.TargetIndex,
+          solution.PackingInformations[tm.Index].ItemIndex,
+          solution.PackingInformations[tm.Index].Rotated,
+          tm.Rotation ^ solution.PackingInformations[tm.Index].Rotated,
+          solution.PackingInformations[tm.Index].AssignedBin,
+          tm.Group,
+          baseQuality);
 
       else return solution;
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/StochasticMCVTripleMoveGenerator.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/StochasticMCVTripleMoveGenerator.cs	(revision 9473)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/StochasticMCVTripleMoveGenerator.cs	(revision 9473)
@@ -0,0 +1,87 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.PackingEncoding.MultiComponentVector {
+  [Item("Stochastic MultiComponentVector Triple Move Generator", "Generates all possible multi component moves from a given multiComponentVector.")]
+  [StorableClass]
+  public class StochasticMCVTripleMoveGenerator : MultiComponentVectorMoveGenerator, IMultiMoveGenerator, IStochasticOperator {
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
+    }
+    public IValueLookupParameter<IntValue> SampleSizeParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["SampleSize"]; }
+    }
+
+    public IntValue SampleSize {
+      get { return SampleSizeParameter.Value; }
+      set { SampleSizeParameter.Value = value; }
+    }
+
+
+    [StorableConstructor]
+    protected StochasticMCVTripleMoveGenerator(bool deserializing) : base(deserializing) { }
+    protected StochasticMCVTripleMoveGenerator(StochasticMCVTripleMoveGenerator original, Cloner cloner) : base(original, cloner) { }
+    public StochasticMCVTripleMoveGenerator()
+      : base() {
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The random number generator."));
+      Parameters.Add(new ValueLookupParameter<IntValue>("SampleSize", "The number of moves to generate."));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new StochasticMCVTripleMoveGenerator(this, cloner);
+    }
+
+    public static List<MultiComponentVectorMove> GenerateMCVTripleMoves(MultiComponentVectorEncoding mcv, IRandom random, int sampleSize) {
+      var result = new List<MultiComponentVectorMove>();
+      var moves = new List<MultiComponentVectorMove> (ExhaustiveMCVTripleMoveGenerator.GenerateMCVTripleMoves(mcv));
+      int moveCount = moves.Count;
+      for (int i = 0; i < sampleSize; i++) {
+        result.Add(moves [random.Next(moveCount)]);
+      }
+      return result;
+    }
+
+    public static MultiComponentVectorMove[] Apply(MultiComponentVectorEncoding multiComponentVector, IRandom random, int sampleSize) {
+      var generatedMoves = GenerateMCVTripleMoves(multiComponentVector, random, sampleSize);
+      int totalMoves = generatedMoves.Count;
+      MultiComponentVectorMove[] moves = new MultiComponentVectorMove[totalMoves];
+      int count = 0;
+      foreach (MultiComponentVectorMove move in generatedMoves) {
+        moves[count++] = move;
+      }
+      return moves;
+    }
+
+    protected override MultiComponentVectorMove[] GenerateMoves(MultiComponentVectorEncoding multiComponentVector) {
+      IRandom random = RandomParameter.ActualValue;
+      return Apply(multiComponentVector, random, SampleSizeParameter.ActualValue.Value);
+    }
+  }
+}
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/StochasticMultiComponentVectorMoveGenerator.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/StochasticMultiComponentVectorMoveGenerator.cs	(revision 9472)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/StochasticMultiComponentVectorMoveGenerator.cs	(revision 9473)
@@ -60,9 +60,10 @@
       MultiComponentVectorMove[] moves = new MultiComponentVectorMove[sampleSize];
       var rm = new List<MultiComponentVectorMove> (GenerateRotationMoves(multiComponentVector));
-      var gm = new List<MultiComponentVectorMove> (GenerateSingleGroupingMoves(multiComponentVector));
-      var sm = new List<MultiComponentVectorMove> (GenerateSwapSequenceMoves(multiComponentVector));
+      var gm = new List<MultiComponentVectorMove>(GenerateSingleGroupingMoves(multiComponentVector));
+      var sm = new List<MultiComponentVectorMove>(GenerateSwapPositionMoves(multiComponentVector));
+      var cpm = new List<MultiComponentVectorMove>(GenerateChangePositionMoves(multiComponentVector));
 
       for (int i = 0; i < sampleSize; i++) {
-        int typeDecision = random.Next(3);
+        int typeDecision = random.Next(4);
         switch (typeDecision) {
           case 0: moves[i] = rm[random.Next(rm.Count)];
@@ -71,4 +72,6 @@
             break;
           case 2: moves[i] = sm[random.Next(sm.Count)];
+            break;
+          case 3: moves[i] = cpm[random.Next(cpm.Count)];
             break;
           default:
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/MultiComponentVectorEncoding.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/MultiComponentVectorEncoding.cs	(revision 9472)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/MultiComponentVectorEncoding.cs	(revision 9473)
@@ -68,5 +68,5 @@
       MultiComponentVectorEncoding mce = obj as MultiComponentVectorEncoding;
       if (mce != null && mce.PackingInformations != null && mce.PackingInformations.Count == this.PackingInformations.Count) {
-        for (int i = 0; i <= mce.PackingInformations.Count; i++) {
+        for (int i = 0; i < mce.PackingInformations.Count; i++) {
           if (mce.PackingInformations[i] != this.PackingInformations[i])
             return false;
@@ -134,5 +134,14 @@
       var result = new ItemList<PackingInformation>();
       foreach (int itemIndex in permutation) {
-        result.Add(new PackingInformation (itemIndex, random.Next(0, lowerBound + 1), random.Next(0,100) > 60 ? true : false));
+        result.Add(new PackingInformation(itemIndex, random.Next(0, lowerBound + 1), random.Next(0, 100) > 60 ? true : false));
+      }
+      return result;
+    }
+
+    public static ItemList<PackingInformation> CreateListRandomlyWithSortedSequence(int items, int lowerBound, IRandom random) {
+      Permutation permutation = new Permutation(PermutationTypes.Absolute, items);
+      var result = new ItemList<PackingInformation>();
+      foreach (int itemIndex in permutation) {
+        result.Add(new PackingInformation(itemIndex, random.Next(0, lowerBound + 1), false));
       }
       return result;
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/MultiComponentVectorRandomCreator.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/MultiComponentVectorRandomCreator.cs	(revision 9472)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/MultiComponentVectorRandomCreator.cs	(revision 9473)
@@ -43,4 +43,7 @@
 			get { return (IValueLookupParameter<IntValue>)Parameters["LowerBound"]; }
 		}
+		public IValueParameter<BoolValue> SortedSequenceParameter {
+			get { return (IValueParameter<BoolValue>)Parameters["SortedSequence"]; }
+		}
 
 		[StorableConstructor]
@@ -52,22 +55,27 @@
 		}
 
-    public MultiComponentVectorRandomCreator()
+		public MultiComponentVectorRandomCreator()
 			: base() {
 			Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator."));
 			Parameters.Add(new ValueLookupParameter<IntValue>("PackingItems", "The number of packing-items handled in this problem instance."));
 			Parameters.Add(new ValueLookupParameter<IntValue>("LowerBound", "The lower possible number of bins needed to solve this problem (taken from Dell'Amico, Martello and Vigo; 2002)"));
+			Parameters.Add(new ValueParameter<BoolValue>("SortedSequence", "Determines if the items of the created instances are to be sorted by their size."));
 
 			EncodedSolutionParameter.ActualName = "MultiComponentVector";
+			SortedSequenceParameter.ActualValue = new BoolValue(false);
 		}
 
 
-    public static MultiComponentVectorEncoding Apply(int items, int lowerBound, IRandom random) {
+		public static MultiComponentVectorEncoding Apply(int items, int lowerBound, IRandom random, bool sortedSequence) {
 			var solution = new MultiComponentVectorEncoding();
-      solution.PackingInformations = PackingInformation.CreateListRandomly(items, lowerBound, random);
+			if (sortedSequence)
+				solution.PackingInformations = PackingInformation.CreateListRandomlyWithSortedSequence(items, lowerBound, random);
+			else
+				solution.PackingInformations = PackingInformation.CreateListRandomly(items, lowerBound, random);
 			return solution;
 		}
 
 		protected override IPackingSolutionEncoding CreateSolution() {
-			return Apply(PackingItemsParameter.ActualValue.Value, LowerBoundParameter.ActualValue.Value, RandomParameter.ActualValue);
+			return Apply(PackingItemsParameter.ActualValue.Value, LowerBoundParameter.ActualValue.Value, RandomParameter.ActualValue, SortedSequenceParameter.Value.Value);
 		}
 	}
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/Potvin/PotvinCrossover.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/Potvin/PotvinCrossover.cs	(revision 9473)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/Potvin/PotvinCrossover.cs	(revision 9473)
@@ -0,0 +1,99 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.IntegerVectorEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.BinPacking.Interfaces;
+
+namespace HeuristicLab.Encodings.PackingEncoding.Potvin {
+  [Item("Potvin Encoding Crossover", "An operator which crosses two Potvin representations. According to RBX by Potvin.")]
+  [StorableClass]
+  public class PotvinCrossover : PackingSolutionCrossover, IPotvinOperator {
+
+    [StorableConstructor]
+    protected PotvinCrossover(bool deserializing) : base(deserializing) { }
+    protected PotvinCrossover(PotvinCrossover original, Cloner cloner) : base(original, cloner) { }
+    public PotvinCrossover()
+      : base() {
+        ParentsParameter.ActualName = "Potvin";
+        ChildParameter.ActualName = "Potvin";
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PotvinCrossover(this, cloner);
+    }
+
+    public PotvinEncoding Cross(IRandom random, PotvinEncoding parent1, PotvinEncoding parent2) {
+      PotvinEncoding child = parent2.Clone() as PotvinEncoding;
+
+      if (parent1.NrOfBins > 0 && child.NrOfBins > 0) {
+        int tourParent1 = random.Next(parent1.NrOfBins);
+        List<int> replacing = parent1.GetItemsInBin(tourParent1);
+
+        int tourParent2 = random.Next(child.NrOfBins);
+        List<int> replaced = child.GetItemsInBin(tourParent2);
+
+        child.Tours.Remove(replaced);
+        child.Tours.Insert(tourParent2, replacing);
+
+        Permutation vehicleAssignment = child.VehicleAssignment;
+
+        int vehicle = vehicleAssignment[tourParent2];
+        int vehicle2 = parent1.VehicleAssignment[tourParent1];
+        vehicleAssignment[tourParent2] = vehicle2;
+
+        for (int i = 0; i < vehicleAssignment.Length; i++) {
+          if (vehicleAssignment[i] == vehicle2 && i != tourParent2) {
+            vehicleAssignment[i] = vehicle;
+            break;
+          }
+        }
+
+        foreach (int city in replaced.Stops)
+          if (FindRoute(child, city) == null && !child.Unrouted.Contains(city))
+            child.Unrouted.Add(city);
+
+        if (Repair(random, child, replacing, problemInstance, allowInfeasible) || allowInfeasible)
+          return child;
+        else {
+          if (random.NextDouble() < 0.5)
+            return parent1.Clone() as PotvinEncoding;
+          else
+            return parent2.Clone() as PotvinEncoding;
+        }
+      } else {
+        return child;
+      }
+    }
+
+    public override IOperation Apply() {
+      var parents = ParentsParameter.ActualValue;
+
+      ChildParameter.ActualValue =
+        Cross(RandomParameter.ActualValue, parents[0] as PotvinEncoding, parents[1] as PotvinEncoding);
+
+      return base.Apply();
+    }
+  }
+}
